Skip to navigation

Submit a data query

View as Markdown

Submits a data query to be executed by Zuora, creating a new query job. Use the Retrieve a data query job endpoint to monitor the job status and access the results once complete.

Note: The request must include the Content-Type: application/json header. If this header is missing, the request will fail with the following error: {"code":415,"message":"HTTP 415 Unsupported Media Type"}

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Request

This endpoint expects an object.
compressionenumRequired
Specifies whether Zuora compresses the query results.
Allowed values:
outputobjectRequired
Additional information about the query results.
outputFormatenumRequired

Specifies the format of the query results.

  • JSON - Each row in the query results will be a JSON object. The format of the query result file is JSON Lines.
  • CSV - Each row in the query results will be a comma-separated list of values.
  • TSV - Each row in the query results will be a tab-separated list of values.
  • DSV - Pass any character as your custom delimiter into the columnSeparator field.
Allowed values:
querystringRequired

The query to perform. See SQL Queries in Data Query for more information.

columnSeparatorstringOptional

The column separator. Only applicable if the outputFormat is DSV.

encryptionKeystringOptionalformat: "byte"

Base-64 encoded public key of an RSA key-pair.

Note that Data Query only supports 1024-bit RSA keys.

If you set this field, Zuora encrypts the query results using the provided public key. You must use the corresponding private key to decrypt the query results.

readDeletedbooleanOptionalDefaults to false

Indicates whether the query will retrieve only the deleted record. If readDeleted is set to false or it is not included in the request body, the query will retrieve only the non-deleted records. If it is set to true, only the deleted records will be retrieved.

If you select the deleted column in the query field, both non-deleted and deleted records will be retrieved regardless of the value in the readDeleted field.

Note that Data Query is subject to Zuora Data Retention Policy. The retention period of deleted data is 30 days. You can only retrieve deleted data for 30 days through Data Query.

sourceDataenumOptional

Specify the source that data queries run against:

  • LIVE represents the live transactional databases at Zuora (Data Query Live).

  • WAREHOUSE represents Zuora Warehouse, which has better performance and fewer limitations than the live transactional database. This option is available only if you have the Zuora Warehouse feature enabled in your tenant. For more information, see Zuora Warehouse.
    If this option is selected, you can specify warehouse size in warehouseSize.

If this field is not specified, the default value LIVE will be used.

Allowed values:
useIndexJoinbooleanOptional

Indicates whether to use Index Join. Index join is useful when you have a specific reference value in your WHERE clause to index another large table by. See Use Index Join for more information.

warehouseSizeenumOptional

Specify the size of Zuora Warehouse. This field is available only if the sourceData is WAREHOUSE.

If this field is not specified or set to NULL, the default value xsmall will be used.

Allowed values:

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.

Response

OK
dataobjectOptional
A data query job.

Errors

400
Bad Request Error
415
Unsupported Media Type Error